{***************************************************************************}
{                             UNIDAD DE CONTROL

                                  Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

UNIT UControl;

INTERFACE

  VAR
    XRaton,
    YRaton,
    BotonRaton : Word;

IMPLEMENTATION

  USES
    UMD;  {Unidad de Mouse Driver}

  VAR
    ViejaLlamadaRaton : Word;
    ViejaRutinaRaton : Pointer;

    ViejoExitProc : Pointer;

{Encabezado basado en la documentacin de Borland Pascal.}
  PROCEDURE AtiendeRaton (Flags, CS, IP, AX, BX, CX, DX, SI, DI, DS, ES, BP :
    Word); INTERRUPT;
  BEGIN
{Adems de Flags, CS e IP; recibe:
  AX = llamada (la misma con que se instal)
  BX = estado de los botones
    binario 0 = 1 SI botn izquierdo fue presionado, 0 SI fue liberado
    binario 1 = 1 SI botn derecho fue presionado, 0 SI fue liberado
  CX = columna
  DX = fila
  DI = movimiento horizontal
  SI = movimiento vertical}

{Guarda los valores importantes.}
    XRaton := CX;
    YRaton := DX;
    BotonRaton := BX;
  END;

{$F+}
  PROCEDURE Sale;
{$F-}
  BEGIN
    ExitProc := ViejoExitProc;

    IF UMD. Error = 0 THEN
    BEGIN
{Quita la interrupcin que recibe valores del manejador.}
      UMD. PoneRutina (ViejaLlamadaRaton, ViejaRutinaRaton);
    END;

  END;

BEGIN

  IF UMD. Error = 0 THEN
  BEGIN
{Instala la interrupcin que recibe valores del manejador cuando se mueve el
ratn, y se presionan y liberan sus botones.}
    UMD. TomaPosicionBoton (BotonRaton, XRaton, YRaton);
    UMD. CambiaRutinas ($ffff, @AtiendeRaton, ViejaLlamadaRaton,
      ViejaRutinaRaton);
  END;

  ViejoExitProc := ExitProc;
  ExitProc := @Sale;
END.